#!/usr/bin/perl -w

use strict;
use funcions;


if (scalar(@ARGV) != 4) {
  print "Per executar el programa: ./programa.pl fitxerfasta fitxermatriu penal_gap penal_ext_gap\n";
  exit;
}

##DEFINICI DE VARIABLES##

my $fastafile = $ARGV[0];                    # arxiu que conte les sequencies a alinear
my $matriu = $ARGV[1];                       # arxiu que conte la matriu de substitucio
my $gap = $ARGV[2];                          # valor del penal per inici de gap
my $gap_e = $ARGV[3];                        # valor del penal per extensio de gap
my $matdist;                                 # referencia a @matdist
my %seq;                                     # hash que conte les sequencies
my @noms;                                    # vector que conte els noms de les sequencies
my @seq;                                     # vector que conte les seqs (1aa per posicio)
my %mat;                                     # hash que conte la matriu. Dues claus.
my @ordre;                                   # vector que determina l'ordre dels aliniaments
my @matdist;                                 # matriu que conte les distancies entre les seqs
my $tree;                                    # variable que conte l'arbre guia
my @nodes;                                   # vector que conte l'ordre de l'aliniament progr.
my $numseq;                                  # variable que conte el nombre de sequencies
my $dist;                                    # referencia a %dist
my %dist;                                    # hash que emmagatzema les distancies de cada node

(%seq) = funcions::llegir_fitxer ($fastafile);  # emmagatzamament de les multiples sequencies
                                                # en un hash.


(%mat) = funcions::llegir_matriu($matriu);      # emmagatzamament matriu i creacio hash %mat


@noms = keys %seq;                              # emmagatzemament dels noms en un vector.
@seq = values %seq;                             # emmagatzemament de les seq. en un altre vector

$numseq = scalar(@seq);
                                                # combinacions 2 a 2 de les seq.
                                                # Determinacio d l'ordre en que farem el
@ordre = funcions::alignment_order (@seq);      # GLOBAL PAIRWISE ALIGNM.
                                                # magatzem en el vector @ordre de les posicions
                                                # de les sequencies a alinear.



#-----------------------------------GLOBAL PAIRWISE ALIGNMENT------------------------------------


($matdist) = funcions::GPA(\@ordre,\@seq,\@noms,\%mat,$gap,$gap_e);


@matdist = @{$matdist};                         # ara tinc una matriu (@matdist) q emmagatzema la
                                                # distancia entre les sequencies.



#-----------------------------------GENERACIO DE L'ARBRE GUIA------------------------------------


($tree,$dist)= funcions::design_tree (\@matdist,$numseq,\@noms);

@nodes = @{$tree};

%dist = %{$dist};

$tree = $nodes[0];


#-------------------------------------ALINEAMENT PROGRESSIU--------------------------------------

### UNDER CONSTRUCTION ###
