package funcions;



################################################################################################
#################################            FUNCIONS              #############################
################################################################################################



#################################################################################################

#NOM: llegir_fitxer


sub llegir_fitxer {
    
    my $fastafile= $ARGV[0];
    if (!open(FASTAFILE,"< $fastafile")) {
	print "programa.pl: no es pot obrir el fitxer $ARGV[0]\n";
	exit;
    }
    my @noms;  #vector que emmagatzemara els noms de les proteines 
    my @seq;   #vector que emmagatzemara les sequencies
    my %seq;   #hash q relaciona noms i sequencies
    my $i = 0; #Index
    my $j = 0; #Index

    open(FASTAFILE,"< $fastafile");
    while (<FASTAFILE>) {
	if (/\A>(\S+)/) {
	    $noms[$j]=$1;
	    $j = $j + 1;
	    $i= $j - 1;
	    $seq[$i]="*";
	}
	elsif (/(\w+)/) {
	    $seq[$i] = $seq[$i].$1;
	}
    }
    close (FASTAFILE);
    $i=0;
    while ($i < scalar (@noms)) {
	$seq{$noms[$i]} = $seq[$i];
	$i++;
    }
    return (%seq);
}


#################################################################################################

#NOM: llegir_matriu



sub llegir_matriu {

    my $matriu = $_[0];

    if (!open (MATFILE, "< $matriu")) {
	print "pugrama.pl: no es pot obrir el fitxer $ARGV[1]\n";
	exit;
    }
    my @aa;    #vector que enregistra els simbols dels aa (una lletra)
    my %mat;   #hash q emmagatzemara la matriu
    my $i = 0; #index
    my $j = 0; #index
    
    open (MATFILE, "< $matriu");
    $_ = <MATFILE>;
    @aa = ($_ =~ m/([A-Z*])/g);
    while (<MATFILE>) {    
	@_= ($_ =~ m/(\-*\d+)/g);
	while ($j < scalar (@aa)) {
	    $mat{$aa[$i]}{$aa[$j]} = $_[$j];
	    $j++;
	}
	$i++;
	$j = 0;
    }
    close (MATFILE);
    return (%mat);

}



#################################################################################################

#NOM: alignment_order


sub alignment_order {

    my @seq = @_;
    my $i = 0;
    my $j = $i + 1;
    my @ordre;       # emmagatzema l'ordre en qu haura d fer els aliniaments
    my $ordre ="";
    
    while ($i < scalar (@seq) && $j < scalar(@seq)) {
	$ordre= $ordre.$i.$j;
	$j = $j + 1;
	if ($j == scalar (@seq)) {
	    $i = $i + 1;
	    $j = $i + 1;
	}
    }
    @ordre = split(//,$ordre);
    return (@ordre);
}


#################################################################################################

#NOM: max


sub max {

    my $diagonal = $_[0];
    my $dalt = $_[1]; 
    my $esq = $_[2];
    my $max;

    if ($diagonal >= $dalt) {
	$max = $diagonal;
    } 
    else {$max = $dalt;}

    if ( $max < $esq) {
	$max = $esq;
    }
    
    if ($max == $diagonal) {
	return $max,1;
    }
    elsif ($max == $dalt) {
	return $max,2;
    }
    elsif ($max == $esq) {
	return $max,3;
    }

}




#################################################################################################

#NOM: alinea


sub alinea  {

    my @seq1 = split (//,$_[0]); ;
    my @seq2 = split (//,$_[1]);;
    my $i = 0;
    my $j = 0;
    my @matALI;
    my @matPROC;
    my $gap = $_[3];
    my $gap_e = $_[4];
    my @aliniament1;
    my @aliniament2;
    my $aa1;
    my $aa2;
    my %mat = %{$_[2]};
    
    
    while ($i < scalar(@seq2)) {
	$matALI[$i][0] = $gap;    #omplim la primera fila amb valor gap (aliniament)
	$matPROC[$i][0] = 0;      #omplim la primera fila amb zeros (procedencia)
	$i = $i + 1;
    }
    while ($j < scalar(@seq1)) {         
	
	$matALI[0][$j] = $gap;    #omplim la primera columna amb valor gap (aliniament)
	$matPROC[0][$j] = 0;      #omplim la primera columna amb zeros (procedencia)
	$j = $j + 1;
    }
    
    $i = 1;
    $j = 1;
    
    while ($i < scalar (@seq2)) {
	
	while ($j < scalar (@seq1)) {
	    
	    if ($matPROC[$i-1][$j] != 2 && $matPROC[$i][$j-1] != 3 ) {
		
		($matALI[$i][$j],$matPROC[$i][$j]) = max ($matALI[$i-1][$j-1]+$mat{$seq1[$j]}{$seq2[$i]},$matALI[$i-1][$j]+$gap,$matALI[$i][$j-1]+$gap);
		
		$j = $j + 1;
	    }
	    
	    elsif ( $matPROC[$i-1][$j] == 2 ) {
		
		($matALI[$i][$j],$matPROC[$i][$j]) = max ($matALI[$i-1][$j-1]+$mat{$seq1[$j]}{$seq2[$i]},$matALI[$i-1][$j]+$gap_e,$matALI[$i][$j-1]+$gap);
		
		$j = $j + 1;
	    }
	    
	    elsif ( $matPROC[$i][$j-1] == 3 ) {
		
		($matALI[$i][$j],$matPROC[$i][$j]) = max ($matALI[$i-1][$j-1]+$mat{$seq1[$j]}{$seq2[$i]},$matALI[$i-1][$j]+$gap,$matALI[$i][$j-1]+$gap_e);
		
		$j = $j + 1;
		
	    }
	    
	}
	
	$j = 1;
	$i = $i + 1;
    }
    
    
    $i = scalar (@seq2)-1;
    $j = scalar (@seq1)-1;
    
    while ($i != 0 && $j != 0) {
	
	if ($matPROC[$i][$j] == 1) {
	    $aa1 = $seq1[$j];
	    $aa2 = $seq2[$i];
	    unshift (@aliniament1,$aa1);
	    unshift (@aliniament2,$aa2);
	    $i = $i - 1;
	    $j = $j - 1;
	}
	elsif ($matPROC[$i][$j] == 2) {
	    $aa1 = "-";
	    $aa2 = $seq2[$i];
	    unshift (@aliniament1,$aa1);
	    unshift (@aliniament2,$aa2);
	    $i = $i - 1;
	}
	elsif ($matPROC[$i][$j] == 3) {
	    $aa1 = $seq1[$j];
	    $aa2 = "-";
	    unshift (@aliniament1,$aa1);
	    unshift (@aliniament2,$aa2);
	    $j = $j - 1;
	}
    }
    while (($i == 0 || $j == 0) && $i != $j ) {
	
	if ($j == 0) {
	    $aa1 = "-";
	    $aa2 = $seq2[$i];
	    unshift (@aliniament1,$aa1);
	    unshift (@aliniament2,$aa2);
	    $i = $i - 1;
	}	
	else { 
	    $aa1 = $seq1[$j];
	    $aa2 = "-";
	    unshift (@aliniament1,$aa1);
	    unshift (@aliniament2,$aa2);
	    $j = $j - 1;
	}
    }
    
    ## la funcio retorna dos vectors que contenen l'aliniament i la puntuacio.
    return (\@aliniament1,\@aliniament2,$matALI[scalar(@seq2)-1][scalar(@seq1)-1]);

}


#################################################################################################

#NOM: torna_aliniament


sub torna_aliniament {
    
    
    my $i = 0;
    my $j = 0;
    my @aliniament1 = @{$_[0]};
    my @aliniament2 = @{$_[1]};
    my @aliniament;
    
    while ($j < scalar (@aliniament1)) {
	$aliniament[$i][$j] = $aliniament1[$j];
	$j = $j + 1;
    }
    $j = 0;
    $i = 1;
    
    while ($j < scalar (@aliniament2)) {
	$aliniament[$i][$j] = $aliniament2[$j];
	$j = $j + 1;
    }
    
    return (@aliniament);
    
}



#################################################################################################

#NOM: max_score


sub max_score {

    my @seq1 = split (//,$_[0]);
    my @seq2 = split (//,$_[1]);
    my %mat = %{$_[2]};
    my $maxscore = 0;
    my $i = 0;

    if (scalar (@seq1) > scalar(@seq2)) {

	while ($i < scalar (@seq1)) {

	    $maxscore = $maxscore + $mat{$seq1[$i]}{$seq1[$i]};
	    $i = $i + 1;
	}
    }
    
    else {

	while ($i < scalar (@seq2)) {

	    $maxscore = $maxscore + $mat{$seq2[$i]}{$seq2[$i]};
	    $i = $i + 1;
	}
    }


return $maxscore;

}




#################################################################################################

#NOM: min_dist


sub min_dist {

    my $i = 0;
    my $j = 0;
    my $min_dist = 1;
    my @matdist = @{$_[0]};
    my $numseq = $_[1];
    my $ref1;
    my $ref2;
    

    while ($i < ($numseq - 1)) {
	
	$j = $i + 1;
	
	while ($j < $numseq) {
	    
	    if ($matdist[$i][$j] < $min_dist ) {
		
		$min_dist = $matdist[$i][$j];
		$ref1 = $i;
		$ref2 = $j;
	    }
	    $j = $j + 1;
	}
	$i = $i + 1;
    }

    
    return ($min_dist,$ref1,$ref2);

}


#################################################################################################

#NOM: order


sub order {

    my @seq = @_;
    my $i = 0;
    my $j = $i + 1;
    my @ordre;       # emmagatzema l'ordre en qu haura d fer els aliniaments
    my $ordre ="";
    
    while ($i < scalar (@seq) && $j < scalar(@seq)-2) {
	$ordre= $ordre.$i.$j;
	$j = $j + 1;
	if ($j == scalar (@seq)-2) {
	    $i = $i + 1;
	    $j = $i + 1;
	}
    }
    @ordre = split(//,$ordre);
    return (@ordre);
}


#################################################################################################

#NOM: GPA
#ACCIO: alinea 2 a 2 totes les sequencies i genera una matriu de distancies inicial

sub GPA {

my @ordre = @{$_[0]};
my @seq = @{$_[1]};
my @noms = @{$_[2]};
my %mat = %{$_[3]};
my $gap = $_[4];
my $gap_e = $_[5];
my $maxscore;
my $score;
my $ref1;
my $ref2;
my $distancia;
my @matdist;
my $i = 0;
my $j = 0;
my $k = 0;

open(OUTFILE,">outfile.txt");                   # genero un arxiu de sortida

while ($k < scalar(@ordre)/2) {                 # mentre recorro el vector ordre

    ($ref1,$ref2,$score) = funcions::alinea ($seq[$ordre[$k*2]],$seq[$ordre[$k*2 + 1]],\%mat,$gap,$gap_e);
    
      
                                                #calculo l'score maxim possible de les dues seq.

    ($maxscore) = funcions::max_score ($seq[$ordre[$k*2]],$seq[$ordre[$k*2 + 1]],\%mat);
    
                                                #emmagatzemo les distancies en un vector
    
    $distancia = (1 - $score/$maxscore);
    

                                                #emmagatzemo en un vector les refs de les
                                                #sequencies q he aliniat i la distancia calculada

    
    $matdist[$ordre[$k*2]][$ordre[$k*2 + 1]] = $distancia;       
    $matdist[$ordre[$k*2+1]][$ordre[$k*2]]= $distancia;
   

    print OUTFILE "Alineo ",$noms[$ordre[$k*2]]," i ",$noms[$ordre[$k*2+1]],": i la distancia es ",$distancia,"\n";

    $k = $k + 1;

}

print OUTFILE "Aquesta es la primera matriu de distancies \n";

$i = 0;
$j = 0;

while ($i < scalar(@matdist)) {
   
	while ($j <= $i) {
	    
	    if ($i == $j) {
		$matdist[$i][$j] = 0;
	    }
	    
	    print OUTFILE "$matdist[$i][$j]\t";
	    $j = $j + 1;
	}
	print OUTFILE "\n";
	$i = $i + 1;
	$j = 0;

    }

print OUTFILE "\n";

close(OUTFILE);

return (\@matdist);

}

#################################################################################################

#NOM: design_tree
#ACCIO: pren la primera @matdist, crea els nodes, recalcula i dissenya l'arbre guia


### ara generare una matriu on emmagatzemare les sequencies com a valors (@matseq) i una altra matriu on emmagatzemare les sequencies com a nodes (@nodes). Com que treballare sobre les matrius i les anire canviant a mesura que ajunto sequencies en nodes, necessitare unes matrius auxiliars: @nodes_copia, i @matdist_copia.


sub design_tree {

    my @matdist = @{$_[0]};
    my $i = 0;
    my $j = 0;
    my $k = 0;
    my $numseq = $_[1];
    my @noms = @{$_[2]};
    my @matseq;
    my $min_dist;
    my $ref1;
    my $ref2;
    my @nodes;
    my @ordre;
    my @matdist_copia;
    my @nodes_copia;
    my %dist;

    while ($i < $numseq ) {   ###inicialitzem les matrius matseq i nodes;
	
	$nodes[$i] = "$i";
	$matseq[$i] = $i;
	$i = $i + 1;
    }
    
    
    while ($numseq >= 2 ) {
	
	
	($min_dist,$ref1,$ref2) = funcions::min_dist(\@matdist, $numseq);
	
	
	while ($j < $numseq - 2) {      ##omplo la matseq amb les sequencies
	    
	    if ( $j < $ref1 ) {
		$i = 0;
	    }
	    elsif ( $j <= ($ref2-2) ) {
		$i = 1;
	    }
	    else { $i = 2; }
	    
	    $matseq[$j] = $j + $i;
	    $j = $j + 1;
	}
	
	$j = 0;
	
	while ($j < $numseq -2) {
	    
	    $nodes_copia[$j]= $nodes[$matseq[$j]];   ## omplo la nodes amb les cadenes
	    $j = $j + 1;
	}
	
	$nodes_copia[$j] = "(".$nodes[$ref1].",".$nodes[$ref2].")";
	
	$dist{$nodes[$ref1]}{$nodes[$ref2]}= $min_dist;

	@nodes = @nodes_copia;
	
	@ordre = funcions::order(@matseq);
        
	$k = 0;
	
	while ($k < scalar(@ordre)/2) {   # mentre recorro el vector ordre
	    
	    $matdist_copia[$ordre[$k*2]][$ordre[$k*2 + 1]]= $matdist[$matseq[$ordre[$k*2]]][$matseq[$ordre[$k*2 + 1]]];
	    $matdist_copia[$ordre[$k*2+1]][$ordre[$k*2]]= $matdist[$matseq[$ordre[$k*2]]][$matseq[$ordre[$k*2 + 1]]];
	    
	    $k = $k + 1;
	}
	
	$j = 0;
	
	pop @matseq;
	
	while ($j < $numseq -2) {
	    
	    
	    $matdist_copia[$j][$numseq-2] = ($matdist[$matseq[$j]][$ref1] + $matdist[$matseq[$j]][$ref2] - $matdist[$ref1][$ref2])/2;
	    $matdist_copia[$numseq-2][$j] = ($matdist[$matseq[$j]][$ref1] + $matdist[$matseq[$j]][$ref2] - $matdist[$ref1][$ref2])/2;
	    
	    
	    $j = $j + 1;
	}
	
	@matdist = @matdist_copia;
        
	$i = 0;
	$j = 0;

	$numseq = $numseq-1;
	
    }
    
    open(OUTFILE,">>outfile.txt");

    print OUTFILE "A partir d'aquestes sequencies ","@noms\n","L'ordre a seguir a l'hora d'aliniar  es: $nodes[0];\n";
    
    close (OUTFILE);

    return (\@nodes,\%dist);

}



1;
